=begin
#WeFitter API

#This is the WeFitter API

OpenAPI spec version: v1.3
Contact: hello@wefitter.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.38
=end

require 'uri'

module WeFitter
  class ChallengeApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create challenge
    # Creates a new challenge
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [ChallengeDetail]
    def challenge_create(data, opts = {})
      data, _status_code, _headers = challenge_create_with_http_info(data, opts)
      data
    end

    # Create challenge
    # Creates a new challenge
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ChallengeDetail, Fixnum, Hash)>] ChallengeDetail data, response status code and response headers
    def challenge_create_with_http_info(data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_create ...'
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling ChallengeApi.challenge_create"
      end
      # resource path
      local_var_path = '/challenge/'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ChallengeDetail')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Deactivate member
    # Deactivate a member from the challenge
    # @param public_id 
    # @param data 
    # @param profile A profile public_id is expected
    # @param [Hash] opts the optional parameters
    # @option opts [String] :team A team public_id is expected
    # @option opts [BOOLEAN] :is_active Whether profile actively participates in challenge.  While inactive, scores/leaderboard will not be updated but still be visible.
    # @return [ProfileAsProfilePublicIdAndTeamAsTeamPublicId]
    def challenge_deactivate_member_create(public_id, data, profile, opts = {})
      data, _status_code, _headers = challenge_deactivate_member_create_with_http_info(public_id, data, profile, opts)
      data
    end

    # Deactivate member
    # Deactivate a member from the challenge
    # @param public_id 
    # @param data 
    # @param profile A profile public_id is expected
    # @param [Hash] opts the optional parameters
    # @option opts [String] :team A team public_id is expected
    # @option opts [BOOLEAN] :is_active Whether profile actively participates in challenge.  While inactive, scores/leaderboard will not be updated but still be visible.
    # @return [Array<(ProfileAsProfilePublicIdAndTeamAsTeamPublicId, Fixnum, Hash)>] ProfileAsProfilePublicIdAndTeamAsTeamPublicId data, response status code and response headers
    def challenge_deactivate_member_create_with_http_info(public_id, data, profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_deactivate_member_create ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_deactivate_member_create"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling ChallengeApi.challenge_deactivate_member_create"
      end
      # verify the required parameter 'profile' is set
      if @api_client.config.client_side_validation && profile.nil?
        fail ArgumentError, "Missing the required parameter 'profile' when calling ChallengeApi.challenge_deactivate_member_create"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/deactivate_member/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'profile'] = profile
      query_params[:'team'] = opts[:'team'] if !opts[:'team'].nil?
      query_params[:'is_active'] = opts[:'is_active'] if !opts[:'is_active'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProfileAsProfilePublicIdAndTeamAsTeamPublicId')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_deactivate_member_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # This docstring is used by Django Rest Framework
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [ProfileAsProfilePublicIdAndTeamAsTeamPublicId]
    def challenge_deactivate_member_update(public_id, data, opts = {})
      data, _status_code, _headers = challenge_deactivate_member_update_with_http_info(public_id, data, opts)
      data
    end

    # This docstring is used by Django Rest Framework
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProfileAsProfilePublicIdAndTeamAsTeamPublicId, Fixnum, Hash)>] ProfileAsProfilePublicIdAndTeamAsTeamPublicId data, response status code and response headers
    def challenge_deactivate_member_update_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_deactivate_member_update ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_deactivate_member_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling ChallengeApi.challenge_deactivate_member_update"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/deactivate_member/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerProfile']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProfileAsProfilePublicIdAndTeamAsTeamPublicId')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_deactivate_member_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Deactivate members
    # Deactivate multiple members from the challenge
    # @param public_id 
    # @param data 
    # @param profile A profile public_id is expected
    # @param [Hash] opts the optional parameters
    # @option opts [String] :team A team public_id is expected
    # @option opts [BOOLEAN] :is_active Whether profile actively participates in challenge.  While inactive, scores/leaderboard will not be updated but still be visible.
    # @return [ProfilePublicIdsListAndTeamAsPublicId]
    def challenge_deactivate_members_create(public_id, data, profile, opts = {})
      data, _status_code, _headers = challenge_deactivate_members_create_with_http_info(public_id, data, profile, opts)
      data
    end

    # Deactivate members
    # Deactivate multiple members from the challenge
    # @param public_id 
    # @param data 
    # @param profile A profile public_id is expected
    # @param [Hash] opts the optional parameters
    # @option opts [String] :team A team public_id is expected
    # @option opts [BOOLEAN] :is_active Whether profile actively participates in challenge.  While inactive, scores/leaderboard will not be updated but still be visible.
    # @return [Array<(ProfilePublicIdsListAndTeamAsPublicId, Fixnum, Hash)>] ProfilePublicIdsListAndTeamAsPublicId data, response status code and response headers
    def challenge_deactivate_members_create_with_http_info(public_id, data, profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_deactivate_members_create ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_deactivate_members_create"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling ChallengeApi.challenge_deactivate_members_create"
      end
      # verify the required parameter 'profile' is set
      if @api_client.config.client_side_validation && profile.nil?
        fail ArgumentError, "Missing the required parameter 'profile' when calling ChallengeApi.challenge_deactivate_members_create"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/deactivate_members/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'profile'] = profile
      query_params[:'team'] = opts[:'team'] if !opts[:'team'].nil?
      query_params[:'is_active'] = opts[:'is_active'] if !opts[:'is_active'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProfilePublicIdsListAndTeamAsPublicId')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_deactivate_members_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # This docstring is used by Django Rest Framework
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [ProfilePublicIdsListAndTeamAsPublicId]
    def challenge_deactivate_members_update(public_id, data, opts = {})
      data, _status_code, _headers = challenge_deactivate_members_update_with_http_info(public_id, data, opts)
      data
    end

    # This docstring is used by Django Rest Framework
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProfilePublicIdsListAndTeamAsPublicId, Fixnum, Hash)>] ProfilePublicIdsListAndTeamAsPublicId data, response status code and response headers
    def challenge_deactivate_members_update_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_deactivate_members_update ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_deactivate_members_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling ChallengeApi.challenge_deactivate_members_update"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/deactivate_members/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerProfile']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProfilePublicIdsListAndTeamAsPublicId')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_deactivate_members_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete challenge
    # deletes a challenge
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def challenge_delete(public_id, opts = {})
      challenge_delete_with_http_info(public_id, opts)
      nil
    end

    # Delete challenge
    # deletes a challenge
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def challenge_delete_with_http_info(public_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_delete ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_delete"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerAdmin']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Leaderboard
    # Displays the leaderboard for a challenge. This endpoint returns a list of objects. 
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :date_range Index of the time period use
    # @return [LeaderboardProfileAndTeam]
    def challenge_leaderboard(public_id, opts = {})
      data, _status_code, _headers = challenge_leaderboard_with_http_info(public_id, opts)
      data
    end

    # Leaderboard
    # Displays the leaderboard for a challenge. This endpoint returns a list of objects. 
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :date_range Index of the time period use
    # @return [Array<(LeaderboardProfileAndTeam, Fixnum, Hash)>] LeaderboardProfileAndTeam data, response status code and response headers
    def challenge_leaderboard_with_http_info(public_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_leaderboard ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_leaderboard"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/leaderboard/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'date_range'] = opts[:'date_range'] if !opts[:'date_range'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'LeaderboardProfileAndTeam')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_leaderboard\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Leaderboard history
    # Retrieve the scores of the authenticated profile for all periods since the profile joined the challenge. This endpoint returns a list of objects. 
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @return [LeaderboardHistory]
    def challenge_leaderboard_history(public_id, opts = {})
      data, _status_code, _headers = challenge_leaderboard_history_with_http_info(public_id, opts)
      data
    end

    # Leaderboard history
    # Retrieve the scores of the authenticated profile for all periods since the profile joined the challenge. This endpoint returns a list of objects. 
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(LeaderboardHistory, Fixnum, Hash)>] LeaderboardHistory data, response status code and response headers
    def challenge_leaderboard_history_with_http_info(public_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_leaderboard_history ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_leaderboard_history"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/leaderboard_history/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerProfile']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'LeaderboardHistory')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_leaderboard_history\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Challenges
    # Lists all available challenges
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Integer] :recent Show challenges that have not ended in the last N weeks
    # @return [InlineResponse200]
    def challenge_list(opts = {})
      data, _status_code, _headers = challenge_list_with_http_info(opts)
      data
    end

    # List Challenges
    # Lists all available challenges
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Integer] :recent Show challenges that have not ended in the last N weeks
    # @return [Array<(InlineResponse200, Fixnum, Hash)>] InlineResponse200 data, response status code and response headers
    def challenge_list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_list ...'
      end
      # resource path
      local_var_path = '/challenge/'

      # query parameters
      query_params = {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'recent'] = opts[:'recent'] if !opts[:'recent'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse200')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Add member
    # Add member to a team.  Note: for now if the challenge is a team challenge and no team is specified, the first team for the specified profile is used. Do note that this is a temporary fix and may be removed at any time. 
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [ProfileAsProfilePublicIdAndTeamAsTeamPublicId]
    def challenge_member_create(public_id, data, opts = {})
      data, _status_code, _headers = challenge_member_create_with_http_info(public_id, data, opts)
      data
    end

    # Add member
    # Add member to a team.  Note: for now if the challenge is a team challenge and no team is specified, the first team for the specified profile is used. Do note that this is a temporary fix and may be removed at any time. 
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProfileAsProfilePublicIdAndTeamAsTeamPublicId, Fixnum, Hash)>] ProfileAsProfilePublicIdAndTeamAsTeamPublicId data, response status code and response headers
    def challenge_member_create_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_member_create ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_member_create"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling ChallengeApi.challenge_member_create"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/member/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProfileAsProfilePublicIdAndTeamAsTeamPublicId')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_member_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Remove member
    # Remove a member from the challenge
    # @param public_id 
    # @param profile A profile public_id is expected
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def challenge_member_delete(public_id, profile, opts = {})
      challenge_member_delete_with_http_info(public_id, profile, opts)
      nil
    end

    # Remove member
    # Remove a member from the challenge
    # @param public_id 
    # @param profile A profile public_id is expected
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def challenge_member_delete_with_http_info(public_id, profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_member_delete ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_member_delete"
      end
      # verify the required parameter 'profile' is set
      if @api_client.config.client_side_validation && profile.nil?
        fail ArgumentError, "Missing the required parameter 'profile' when calling ChallengeApi.challenge_member_delete"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/member/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'profile'] = profile

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_member_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Add member
    # Add member to a team.  Note: for now if the challenge is a team challenge and no team is specified, the first team for the specified profile is used. Do note that this is a temporary fix and may be removed at any time. 
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [ProfileAsProfilePublicIdAndTeamAsTeamPublicId]
    def challenge_member_update(public_id, data, opts = {})
      data, _status_code, _headers = challenge_member_update_with_http_info(public_id, data, opts)
      data
    end

    # Add member
    # Add member to a team.  Note: for now if the challenge is a team challenge and no team is specified, the first team for the specified profile is used. Do note that this is a temporary fix and may be removed at any time. 
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProfileAsProfilePublicIdAndTeamAsTeamPublicId, Fixnum, Hash)>] ProfileAsProfilePublicIdAndTeamAsTeamPublicId data, response status code and response headers
    def challenge_member_update_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_member_update ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_member_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling ChallengeApi.challenge_member_update"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/member/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProfileAsProfilePublicIdAndTeamAsTeamPublicId')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_member_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Add members
    # Add members to a team.  Note: for now if the challenge is a team challenge and no team is specified, the first team for the specified profile is used. Do note that this is a temporary fix and may be removed at any time.  Note: for the GET/POST endpoint an admin bearer token is required, while the GET also accepts profile bearer tokens
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [ProfilePublicIdsListAndTeamAsPublicId]
    def challenge_members_create(public_id, data, opts = {})
      data, _status_code, _headers = challenge_members_create_with_http_info(public_id, data, opts)
      data
    end

    # Add members
    # Add members to a team.  Note: for now if the challenge is a team challenge and no team is specified, the first team for the specified profile is used. Do note that this is a temporary fix and may be removed at any time.  Note: for the GET/POST endpoint an admin bearer token is required, while the GET also accepts profile bearer tokens
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProfilePublicIdsListAndTeamAsPublicId, Fixnum, Hash)>] ProfilePublicIdsListAndTeamAsPublicId data, response status code and response headers
    def challenge_members_create_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_members_create ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_members_create"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling ChallengeApi.challenge_members_create"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/members/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProfilePublicIdsListAndTeamAsPublicId')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_members_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get members
    # Get a paginated list of members enrolled to a Challenge
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @return [InlineResponse2002]
    def challenge_members_read(public_id, opts = {})
      data, _status_code, _headers = challenge_members_read_with_http_info(public_id, opts)
      data
    end

    # Get members
    # Get a paginated list of members enrolled to a Challenge
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @return [Array<(InlineResponse2002, Fixnum, Hash)>] InlineResponse2002 data, response status code and response headers
    def challenge_members_read_with_http_info(public_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_members_read ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_members_read"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/members/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2002')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_members_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Add members
    # Add members to a team.  Note: for now if the challenge is a team challenge and no team is specified, the first team for the specified profile is used. Do note that this is a temporary fix and may be removed at any time.  Note: for the GET/POST endpoint an admin bearer token is required, while the GET also accepts profile bearer tokens
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [ProfilePublicIdsListAndTeamAsPublicId]
    def challenge_members_update(public_id, data, opts = {})
      data, _status_code, _headers = challenge_members_update_with_http_info(public_id, data, opts)
      data
    end

    # Add members
    # Add members to a team.  Note: for now if the challenge is a team challenge and no team is specified, the first team for the specified profile is used. Do note that this is a temporary fix and may be removed at any time.  Note: for the GET/POST endpoint an admin bearer token is required, while the GET also accepts profile bearer tokens
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProfilePublicIdsListAndTeamAsPublicId, Fixnum, Hash)>] ProfilePublicIdsListAndTeamAsPublicId data, response status code and response headers
    def challenge_members_update_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_members_update ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_members_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling ChallengeApi.challenge_members_update"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/members/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProfilePublicIdsListAndTeamAsPublicId')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_members_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Partial edit challenge
    # Edits a challenge
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [ChallengeDetail]
    def challenge_partial_update(public_id, data, opts = {})
      data, _status_code, _headers = challenge_partial_update_with_http_info(public_id, data, opts)
      data
    end

    # Partial edit challenge
    # Edits a challenge
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ChallengeDetail, Fixnum, Hash)>] ChallengeDetail data, response status code and response headers
    def challenge_partial_update_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_partial_update ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_partial_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling ChallengeApi.challenge_partial_update"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ChallengeDetail')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Periods
    # Get all periods for the challenge. This endpoint returns a list of objects. 
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @return [ChallengePeriod]
    def challenge_periods(public_id, opts = {})
      data, _status_code, _headers = challenge_periods_with_http_info(public_id, opts)
      data
    end

    # Periods
    # Get all periods for the challenge. This endpoint returns a list of objects. 
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ChallengePeriod, Fixnum, Hash)>] ChallengePeriod data, response status code and response headers
    def challenge_periods_with_http_info(public_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_periods ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_periods"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/periods/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ChallengePeriod')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_periods\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get Challenge
    # Gets a single challenge
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @return [ChallengeDetail]
    def challenge_read(public_id, opts = {})
      data, _status_code, _headers = challenge_read_with_http_info(public_id, opts)
      data
    end

    # Get Challenge
    # Gets a single challenge
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ChallengeDetail, Fixnum, Hash)>] ChallengeDetail data, response status code and response headers
    def challenge_read_with_http_info(public_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_read ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_read"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ChallengeDetail')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Remove members
    # Remove members from the challenge
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [ProfilePublicIdsListAndTeamAsPublicId]
    def challenge_remove_members(public_id, data, opts = {})
      data, _status_code, _headers = challenge_remove_members_with_http_info(public_id, data, opts)
      data
    end

    # Remove members
    # Remove members from the challenge
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProfilePublicIdsListAndTeamAsPublicId, Fixnum, Hash)>] ProfilePublicIdsListAndTeamAsPublicId data, response status code and response headers
    def challenge_remove_members_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_remove_members ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_remove_members"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling ChallengeApi.challenge_remove_members"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/remove_members/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProfilePublicIdsListAndTeamAsPublicId')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_remove_members\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Team leaderboard
    # List the standings of different teams in challenges (don't have to be team challenges). This endpoint returns a list of objects. 
    # @param challenge_public_id 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Integer] :date_range Index of the time period use
    # @return [InlineResponse2001]
    def challenge_team_list(challenge_public_id, opts = {})
      data, _status_code, _headers = challenge_team_list_with_http_info(challenge_public_id, opts)
      data
    end

    # Team leaderboard
    # List the standings of different teams in challenges (don&#39;t have to be team challenges). This endpoint returns a list of objects. 
    # @param challenge_public_id 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Integer] :date_range Index of the time period use
    # @return [Array<(InlineResponse2001, Fixnum, Hash)>] InlineResponse2001 data, response status code and response headers
    def challenge_team_list_with_http_info(challenge_public_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_team_list ...'
      end
      # verify the required parameter 'challenge_public_id' is set
      if @api_client.config.client_side_validation && challenge_public_id.nil?
        fail ArgumentError, "Missing the required parameter 'challenge_public_id' when calling ChallengeApi.challenge_team_list"
      end
      # resource path
      local_var_path = '/challenge/{challenge_public_id}/team/'.sub('{' + 'challenge_public_id' + '}', challenge_public_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'date_range'] = opts[:'date_range'] if !opts[:'date_range'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2001')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_team_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Team contribution
    # List team members' contribution to the challenge. This endpoint returns a list of objects. 
    # @param challenge_public_id 
    # @param team_public_id 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :date_range Index of the time period use
    # @return [LeaderboardProfile]
    def challenge_team_read(challenge_public_id, team_public_id, opts = {})
      data, _status_code, _headers = challenge_team_read_with_http_info(challenge_public_id, team_public_id, opts)
      data
    end

    # Team contribution
    # List team members&#39; contribution to the challenge. This endpoint returns a list of objects. 
    # @param challenge_public_id 
    # @param team_public_id 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :date_range Index of the time period use
    # @return [Array<(LeaderboardProfile, Fixnum, Hash)>] LeaderboardProfile data, response status code and response headers
    def challenge_team_read_with_http_info(challenge_public_id, team_public_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_team_read ...'
      end
      # verify the required parameter 'challenge_public_id' is set
      if @api_client.config.client_side_validation && challenge_public_id.nil?
        fail ArgumentError, "Missing the required parameter 'challenge_public_id' when calling ChallengeApi.challenge_team_read"
      end
      # verify the required parameter 'team_public_id' is set
      if @api_client.config.client_side_validation && team_public_id.nil?
        fail ArgumentError, "Missing the required parameter 'team_public_id' when calling ChallengeApi.challenge_team_read"
      end
      # resource path
      local_var_path = '/challenge/{challenge_public_id}/team/{team_public_id}/'.sub('{' + 'challenge_public_id' + '}', challenge_public_id.to_s).sub('{' + 'team_public_id' + '}', team_public_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'date_range'] = opts[:'date_range'] if !opts[:'date_range'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'LeaderboardProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_team_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Edit challenge
    # Edits a challenge
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [ChallengeDetail]
    def challenge_update(public_id, data, opts = {})
      data, _status_code, _headers = challenge_update_with_http_info(public_id, data, opts)
      data
    end

    # Edit challenge
    # Edits a challenge
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ChallengeDetail, Fixnum, Hash)>] ChallengeDetail data, response status code and response headers
    def challenge_update_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChallengeApi.challenge_update ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling ChallengeApi.challenge_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling ChallengeApi.challenge_update"
      end
      # resource path
      local_var_path = '/challenge/{public_id}/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ChallengeDetail')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChallengeApi#challenge_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
